<?php
/**
* JoomlaWatch - A real-time ajax joomla monitor and live stats
* @version 1.2.0
* @package JoomlaWatch
* @license http://www.gnu.org/licenses/gpl-3.0.txt 	GNU General Public License v3
* @copyright (C) 2007 by Matej Koval - All rights reserved! 
* @website http://www.codegravity.com
**/

class JoomlaWatchHTML {


	function getRand() {
		global $database;
		$query = "select value from #__joomlawatch_helper where name = 'rand' order by id desc limit 1";
		$database->setQuery($query);
		$database->query();
		$rows = $database->loadObjectList();
		$row = @ $rows[0];

		$rand = @ $row->value;

		return $rand;

	}

	function render($option) {
		global $database, $mainframe, $mosConfig_live_site, $mosConfig_absolute_path;

		require_once ($mosConfig_absolute_path . "/components/com_joomlawatch/config.php");
?>
<style type="text/css">
        TR, TD { font-family: verdana, helvetica, arial; font-size:10px;}
        .tab_active { 
        	background-position: top center; 
        	background-image: url(<?php echo($mosConfig_live_site);?>/components/com_joomlawatch/icons/tab-on.gif);
        	width:100px;
        }
              .tab_inactive { 
        	background-position: top center; 
        	background-image: url(<?php echo($mosConfig_live_site);?>/components/com_joomlawatch/icons/tab-off.gif);
        	width:100px;
        }
              .tab_none { 
        	background-position: bottom center; 
        	background-image: url(<?php echo($mosConfig_live_site);?>/components/com_joomlawatch/icons/tab-none.gif);
        	width:20px;
        	background-repeat: no-repeat;
        }
        
</style>
        
<script src='<?php echo($mosConfig_live_site);?>/components/com_joomlawatch/js/fade.js'></script>

<span id='status'></span>



<script type="text/javascript" language="JavaScript">


var last=null;
var http=null;
var day = 0;
var week = 0;
var expanded = new Array();
var statsType = "daily";
var rand='<?php echo JoomlaWatchHTML :: getRand(); ?>';

function setDay(_day) {
 day = _day;
 document.getElementById(_day).innerHTML = "loading... please wait";	
 sendStatsReq();
}
function setStatsType(_statsType) {
 statsType = _statsType;
 document.getElementById(_statsType).innerHTML = "loading...";	
 sendStatsReq();
}
function setWeek(_week) {
 week = _week;
 document.getElementById("visits_" + _week).innerHTML = "loading... please wait";	
 sendStatsReq();
}

function createRequestObject() {
    var ro;
    if(window.ActiveXObject){
        ro = new ActiveXObject("Microsoft.XMLHTTP");
    }else{
        ro = new XMLHttpRequest();
    }
    return ro;
}

function sendVisitsReq() {
try {
    http = createRequestObject();
    http.onreadystatechange = needVisitsRefresh;
    var newdate = new Date();	
    var url = "<?php echo($mosConfig_live_site);?>/components/com_joomlawatch/visits.php?rand=" + rand + "&timeID="+newdate.getTime();
    http.open("GET", url, true);
    http.send(null);
}
catch (err) { 
try {
if ((window.ActiveXObject && err.message.substring(0,17) == "Permission denied") || (!window.ActiveXObject  && err.substring(0,17) == "Permission denied"))
alert("AJAX permission denied: Please view this statistics from domain you specified in configuration.php of joomla - <?php echo($mosConfig_live_site);?>. Maybe you just forgotten www. in front of your domain name. Your javascript is trying to access <?php echo($mosConfig_live_site);?> from <?php echo(str_replace("www.","",$mosConfig_live_site));?> what makes it to think it's a different domain.");
} catch(err2) {
}
}

}

function sendStatsReq() {
try {
    http2 = createRequestObject();
    http2.onreadystatechange = needStatsRefresh;
    var newdate = new Date();	
    var url = "<?php echo($mosConfig_live_site);?>/components/com_joomlawatch/stats.php?rand=" + rand + "&timeID="+newdate.getTime();
    if (day != 0) url += "&day="+day;
    if (week != 0) url += "&week="+week;
    if (expand["countries"]) url += "&countries=true";
    if (expand["browser"]) url += "&browser=true";
    if (expand["os"]) url += "&os=true";
    if (expand["uri"]) url += "&uri=true";

    if (expand["all_countries"]) url += "&all_countries=true";
    if (expand["all_browser"]) url += "&all_browser=true";
    if (expand["all_os"]) url += "&all_os=true";
    if (expand["all_uri"]) url += "&all_uri=true";
    
    if (statsType == "alltime") url += "&alltime=true";
    
    http2.open("GET", url, true);
    http2.send(null);
}
catch (err) {
}
}


function expand(_element) {
	if (!expand[_element]) expand[_element] = true;
		else expand[_element] = false;
	document.getElementById(_element).innerHTML = "loading... please wait";	
	sendVisitsReq();
}

function needVisitsRefresh()
{
try {
  if (http.readyState == 4) 
  {
     if(http.status == 200)
     {
         document.getElementById("visits").innerHTML = http.responseText;
         
         
         number = "";
         for (i=0 ; i<11; i++ ) {		
         if (http.responseText.charAt(i) == '\n') break;
         if (http.responseText.charAt(i) == '\r') break;
         if (http.responseText.charAt(i) == ' ') break;
         
         number = number + http.responseText.charAt(i);
         }
         
         number = number.replace(/(<([^>]+)>)/ig,"");	
         parsedNumber = parseInt(number);
         
         if (last != parsedNumber) {
         	   last = parsedNumber;
         	fade("id" + last);
         }
     }

	  window.setTimeout("sendVisitsReq()",<?php echo(JOOMLAWATCH_UPDATE_TIME_VISITS);?>);
  }
} catch (err) {
}
}

function needStatsRefresh()
{
try {
  if (http2.readyState == 4) 
  {
     if(http2.status == 200)
     {
         document.getElementById("stats").innerHTML = http2.responseText;
     }
	  window.setTimeout("sendStatsReq()",<?php echo(JOOMLAWATCH_UPDATE_TIME_STATS);?>);
  }
} catch (err) {
}
}

</script>

<script>sendVisitsReq(); sendStatsReq();</script>

	<div align='left'>
	<table>
	<tr><td>
	<a href='http://www.codegravity.com' target='_blank'><img src='<?php echo($mosConfig_live_site);?>/components/com_joomlawatch/icons/joomlawatch-logo-32x32.gif' align='center' border='0'/></a>
	</td><td>
	<a href='http://www.codegravity.com' target='_blank' style='font-family: verdana; font-size: 14px; align:top; font-weight: bold; color: black;'>JoomlaWatch <?php echo(JOOMLAWATCH_VERSION);?></a><br/>A real-time AJAX joomla monitor
	</td>
	</tr>
	</table>
	</div>
	<div align='right'>
			For the latest version, please visit <a href='http://www.codegravity.com' target='_blank'>CodeGravity.com</a>
			</div>
    <table border='0' cellpadding='2'>
    <tr>
    <td id="visits" valign='top' align='left'>
    Loading visits...
    </td>
    <td id="stats" valign='top'  align='left'>
    Loading stats..
    </td>
    </tr>
	</table>    
 <?php


	}
}
?>